#!/usr/bin/env sh

set -eu

GHDLFLAGS="--std=08 --workdir=workdir"

mkdir -p workdir

ghdl remove $GHDLFLAGS
ghdl analyze $GHDLFLAGS parser.vhd verifier.vhd top.vhd sim.vhd
ghdl elab-run $GHDLFLAGS sim -gSTEP=1 -gFILENAME="../input.txt"
ghdl elab-run $GHDLFLAGS sim -gSTEP=2 -gFILENAME="../input.txt"

echo "Synthesized: "

for step in 1 2; do
	ghdl remove $GHDLFLAGS
	ghdl synth $GHDLFLAGS -gCOUNTER_WIDTH=12 -gSTEP="$step" parser.vhd verifier.vhd top.vhd -e top > top_syn.vhd
	ghdl analyze $GHDLFLAGS top_syn.vhd sim.vhd
	ghdl elab-run $GHDLFLAGS sim -gSTEP="$step" -gFILENAME="../input.txt" --ieee-asserts=disable-at-0
done
